Index: /LMDZ5/trunk/libf/dyn3dpar/gcm.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3dpar/gcm.F	(revision 1453)
+++ /LMDZ5/trunk/libf/dyn3dpar/gcm.F	(revision 1454)
@@ -276,18 +276,10 @@
         endif
 
-        if (planet_type.eq."earth") then
-#ifdef CPP_EARTH
+!        if (planet_type.eq."earth") then
 ! Load an Earth-format start file
          CALL dynetat0("start.nc",vcov,ucov,
      &              teta,q,masse,ps,phis, time_0)
-#else
-        ! SW model also has Earth-format start files
-        ! (but can be used without the CPP_EARTH directive)
-          if (iflag_phys.eq.0) then
-            CALL dynetat0("start.nc",vcov,ucov,
-     &              teta,q,masse,ps,phis, time_0)
-          endif
-#endif
-        endif ! of if (planet_type.eq."earth")
+!        endif ! of if (planet_type.eq."earth")
+
 c       write(73,*) 'ucov',ucov
 c       write(74,*) 'vcov',vcov
@@ -494,7 +486,8 @@
 #endif
 
-      if (planet_type.eq."earth") then
+!      if (planet_type.eq."earth") then
+! Write an Earth-format restart file
         CALL dynredem0_p("restart.nc", day_end, phis)
-      endif
+!      endif
 
       ecripar = .TRUE.
Index: /LMDZ5/trunk/libf/dyn3dpar/grid_noro.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3dpar/grid_noro.F	(revision 1453)
+++ /LMDZ5/trunk/libf/dyn3dpar/grid_noro.F	(revision 1454)
@@ -458,10 +458,7 @@
 C MAKE A MOVING AVERAGE OVER 9 GRIDPOINTS OF THE X FIELDS
 
-      PARAMETER (ISMo=300,JSMo=200)
-      REAL X(IMAR,JMAR),XF(ISMo,JSMo)
+      REAL X(IMAR,JMAR),XF(IMAR,JMAR)
       real WEIGHTpb(-1:1,-1:1)
 
-      if(imar.gt.ismo) stop'surdimensionner ismo dans mva9 (grid_noro)'
-      if(jmar.gt.jsmo) stop'surdimensionner jsmo dans mva9 (grid_noro)'
       
       SUM=0.
Index: /LMDZ5/trunk/libf/dyn3dpar/infotrac.F90
===================================================================
--- /LMDZ5/trunk/libf/dyn3dpar/infotrac.F90	(revision 1453)
+++ /LMDZ5/trunk/libf/dyn3dpar/infotrac.F90	(revision 1454)
@@ -61,10 +61,10 @@
     CHARACTER(len=1), DIMENSION(3)  :: txts
     CHARACTER(len=2), DIMENSION(9)  :: txtp
-    CHARACTER(len=13)               :: str1,str2
+    CHARACTER(len=23)               :: str1,str2
   
     INTEGER :: nqtrue  ! number of tracers read from tracer.def, without higer order of moment
     INTEGER :: iq, new_iq, iiq, jq, ierr
-    INTEGER, EXTERNAL :: lnblnk
- 
+
+    character(len=*),parameter :: modname="infotrac_init"
 !-----------------------------------------------------------------------
 ! Initialization :
@@ -100,13 +100,23 @@
        OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
        IF(ierr.EQ.0) THEN
-          WRITE(lunout,*) 'Open traceur.def : ok'
+          WRITE(lunout,*) trim(modname),': Open traceur.def : ok'
           READ(90,*) nqtrue
        ELSE 
-          WRITE(lunout,*) 'Problem in opening traceur.def'
-          WRITE(lunout,*) 'ATTENTION using defaut values'
-          nqtrue=4 ! Defaut value
-       END IF
-       ! Attention! Only for planet_type=='earth'
-       nbtr=nqtrue-2
+          WRITE(lunout,*) trim(modname),': Problem in opening traceur.def'
+          WRITE(lunout,*) trim(modname),': WARNING using defaut values'
+          if (planet_type=='earth') then
+            nqtrue=4 ! Default value for Earth
+          else
+            nqtrue=1 ! Default value for other planets
+          endif
+       END IF
+       if ( planet_type=='earth') then
+         ! For Earth, water vapour & liquid tracers are not in the physics
+         nbtr=nqtrue-2
+       else
+         ! Other planets (for now); we have the same number of tracers
+         ! in the dynamics than in the physics
+         nbtr=nqtrue
+       endif
     ELSE
        ! nbtr has been read from INCA by init_cont_lmdz() in gcm.F 
@@ -114,6 +124,6 @@
     END IF
 
-    IF (nqtrue < 2) THEN
-       WRITE(lunout,*) 'nqtrue=',nqtrue, ' is not allowded. 2 tracers is the minimum'
+    IF ((planet_type=="earth").and.(nqtrue < 2)) THEN
+       WRITE(lunout,*) trim(modname),': nqtrue=',nqtrue, ' is not allowded. 2 tracers is the minimum'
        CALL abort_gcm('infotrac_init','Not enough tracers',1)
     END IF
@@ -156,8 +166,10 @@
           ! Continue to read tracer.def
           DO iq=1,nqtrue
-             READ(90,999) hadv(iq),vadv(iq),tnom_0(iq)
+             READ(90,*) hadv(iq),vadv(iq),tnom_0(iq)
           END DO
           CLOSE(90)  
-       ELSE ! Without tracer.def
+       ELSE ! Without tracer.def, set default values 
+         if (planet_type=="earth") then
+          ! for Earth, default is to have 4 tracers
           hadv(1) = 14
           vadv(1) = 14
@@ -172,8 +184,13 @@
           vadv(4) = 10
           tnom_0(4) = 'PB'
+         else ! default for other planets
+          hadv(1) = 10
+          vadv(1) = 10
+          tnom_0(1) = 'dummy'
+         endif ! of if (planet_type=="earth")
        END IF
        
-       WRITE(lunout,*) 'Valeur de traceur.def :'
-       WRITE(lunout,*) 'nombre de traceurs ',nqtrue
+       WRITE(lunout,*) trim(modname),': Valeur de traceur.def :'
+       WRITE(lunout,*) trim(modname),': nombre de traceurs ',nqtrue
        DO iq=1,nqtrue
           WRITE(lunout,*) hadv(iq),vadv(iq),tnom_0(iq)
@@ -217,5 +234,5 @@
           new_iq=new_iq+10 ! 9 tracers added
        ELSE
-          WRITE(lunout,*) 'This choice of advection schema is not available'
+          WRITE(lunout,*) trim(modname),': This choice of advection schema is not available',iq,hadv(iq),vadv(iq)
           CALL abort_gcm('infotrac_init','Bad choice of advection schema - 1',1)
        END IF
@@ -227,8 +244,8 @@
        nqtot = new_iq
 
-       WRITE(lunout,*) 'The choice of advection schema for one or more tracers'
+       WRITE(lunout,*) trim(modname),': The choice of advection schema for one or more tracers'
        WRITE(lunout,*) 'makes it necessary to add tracers'
-       WRITE(lunout,*) nqtrue,' is the number of true tracers'
-       WRITE(lunout,*) nqtot, ' is the total number of tracers needed'
+       WRITE(lunout,*) trim(modname)//': ',nqtrue,' is the number of true tracers'
+       WRITE(lunout,*) trim(modname)//': ',nqtot, ' is the total number of tracers needed'
 
     ELSE
@@ -258,5 +275,6 @@
           iadv(new_iq)=11
        ELSE
-          WRITE(lunout,*)'This choice of advection schema is not available'
+          WRITE(lunout,*)trim(modname),': This choice of advection schema is not available',iq,hadv(iq),vadv(iq)
+
           CALL abort_gcm('infotrac_init','Bad choice of advection schema - 2',1)
        END IF
@@ -265,7 +283,7 @@
        tname(new_iq)= tnom_0(iq)
        IF (iadv(new_iq)==0) THEN
-          ttext(new_iq)=str1(1:lnblnk(str1))
+          ttext(new_iq)=trim(str1)
        ELSE
-          ttext(new_iq)=str1(1:lnblnk(str1))//descrq(iadv(new_iq))
+          ttext(new_iq)=trim(tnom_0(iq))//descrq(iadv(new_iq))
        END IF
 
@@ -276,6 +294,6 @@
              new_iq=new_iq+1
              iadv(new_iq)=-20
-             ttext(new_iq)=str2(1:lnblnk(str2))//txts(jq)
-             tname(new_iq)=str1(1:lnblnk(str1))//txts(jq)
+             ttext(new_iq)=trim(str2)//txts(jq)
+             tname(new_iq)=trim(str1)//txts(jq)
           END DO
        ELSE IF (iadv(new_iq)==30) THEN
@@ -283,6 +301,6 @@
              new_iq=new_iq+1
              iadv(new_iq)=-30
-             ttext(new_iq)=str2(1:lnblnk(str2))//txtp(jq)
-             tname(new_iq)=str1(1:lnblnk(str1))//txtp(jq)
+             ttext(new_iq)=trim(str2)//txtp(jq)
+             tname(new_iq)=trim(str1)//txtp(jq)
           END DO
        END IF
@@ -303,8 +321,9 @@
 
 
-    WRITE(lunout,*) 'Information stored in infotrac :'
-    WRITE(lunout,*) 'iadv  niadv tname  ttext :'
+    WRITE(lunout,*) trim(modname),': Information stored in infotrac :'
+    WRITE(lunout,*) trim(modname),': iadv  niadv tname  ttext :'
     DO iq=1,nqtot
-       WRITE(lunout,*) iadv(iq),niadv(iq), tname(iq), ttext(iq)
+       WRITE(lunout,*) iadv(iq),niadv(iq),&
+       ' ',trim(tname(iq)),' ',trim(ttext(iq))
     END DO
 
@@ -315,8 +334,8 @@
     DO iq=1,nqtot
        IF (iadv(iq)/=10 .AND. iadv(iq)/=14 .AND. iadv(iq)/=0) THEN
-          WRITE(lunout,*)'STOP : The option iadv=',iadv(iq),' is not tested in this version of LMDZ'
+          WRITE(lunout,*)trim(modname),' STOP : The option iadv=',iadv(iq),' is not tested in this version of LMDZ'
           CALL abort_gcm('infotrac_init','In this version only iadv=10 and iadv=14 is tested!',1)
        ELSE IF (iadv(iq)==14 .AND. iq/=1) THEN
-          WRITE(lunout,*)'STOP : The option iadv=',iadv(iq),' is not tested in this version of LMDZ'
+          WRITE(lunout,*)trim(modname),'STOP : The option iadv=',iadv(iq),' is not tested in this version of LMDZ'
           CALL abort_gcm('infotrac_init','In this version iadv=14 is only permitted for water vapour!',1)
        END IF
@@ -329,6 +348,4 @@
     DEALLOCATE(tracnam)
 
-999 FORMAT (i2,1x,i2,1x,a15)
-
   END SUBROUTINE infotrac_init
 
Index: /LMDZ5/trunk/libf/dyn3dpar/iniacademic.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3dpar/iniacademic.F	(revision 1453)
+++ /LMDZ5/trunk/libf/dyn3dpar/iniacademic.F	(revision 1454)
@@ -8,5 +8,12 @@
       USE filtreg_mod
       USE infotrac, ONLY : nqtot
-      USE control_mod
+      USE control_mod, ONLY: day_step,planet_type
+#ifdef CPP_IOIPSL
+      USE IOIPSL
+#else
+! if not using IOIPSL, we still need to use (a local version of) getin
+      USE ioipsl_getincom
+#endif
+      USE Write_Field
  
 
@@ -70,8 +77,14 @@
       REAL pkf(ip1jmp1,llm)                  ! exner filt.au milieu des couches
       REAL phi(ip1jmp1,llm)                  ! geopotentiel
-      REAL ddsin,tetarappelj,tetarappell,zsig
+      REAL ddsin,tetastrat,zsig,tetapv,w_pv  ! variables auxiliaires
       real tetajl(jjp1,llm)
       INTEGER i,j,l,lsup,ij
 
+      REAL teta0,ttp,delt_y,delt_z,eps ! Constantes pour profil de T
+      REAL k_f,k_c_a,k_c_s         ! Constantes de rappel
+      LOGICAL ok_geost             ! Initialisation vent geost. ou nul
+      LOGICAL ok_pv                ! Polar Vortex
+      REAL phi_pv,dphi_pv,gam_pv   ! Constantes pour polar vortex 
+      
       real zz,ran1
       integer idum
@@ -82,23 +95,17 @@
 ! 1. Initializations for Earth-like case
 ! --------------------------------------
-      if (planet_type=="earth") then
-c
+c
+        ! initialize planet radius, rotation rate,...
+        call conf_planete
+
         time_0=0.
-        day_ref=0
+        day_ref=1
         annee_ref=0
 
         im         = iim
         jm         = jjm
-        day_ini    = 0
-        omeg       = 4.*asin(1.)/86400.
-        rad    = 6371229.
-        g      = 9.8
-        daysec = 86400.
+        day_ini    = 1
         dtvr    = daysec/REAL(day_step)
         zdtvr=dtvr
-        kappa  = 0.2857143
-        cpp    = 1004.70885
-        preff     = 101325.
-        pa        =  50000.
         etot0      = 0.
         ptot0      = 0.
@@ -120,7 +127,5 @@
           if (.not.read_start) then
             phis(:)=0.
-            q(:,:,1)=1.e-10
-            q(:,:,2)=1.e-15
-            q(:,:,3:nqtot)=0.
+            q(:,:,:)=0
             CALL sw_case_williamson91_6(vcov,ucov,teta,masse,ps)
           endif
@@ -129,30 +134,78 @@
         if (iflag_phys.eq.2) then
           ! initializations for the academic case
-          ps(:)=1.e5
-          phis(:)=0.
-c---------------------------------------------------------------------
-
-          taurappel=10.*daysec
-
-c---------------------------------------------------------------------
-c   Calcul de la temperature potentielle :
-c   --------------------------------------
-
+          
+!         if (planet_type=="earth") then
+
+          ! 1. local parameters
+          ! by convention, winter is in the southern hemisphere
+          ! Geostrophic wind or no wind?
+          ok_geost=.TRUE.
+          CALL getin('ok_geost',ok_geost)
+          ! Constants for Newtonian relaxation and friction
+          k_f=1.                !friction 
+          CALL getin('k_j',k_f)
+          k_f=1./(daysec*k_f)
+          k_c_s=4.  !cooling surface
+          CALL getin('k_c_s',k_c_s)
+          k_c_s=1./(daysec*k_c_s)
+          k_c_a=40. !cooling free atm
+          CALL getin('k_c_a',k_c_a)
+          k_c_a=1./(daysec*k_c_a)
+          ! Constants for Teta equilibrium profile
+          teta0=315.     ! mean Teta (S.H. 315K)
+          CALL getin('teta0',teta0)
+          ttp=200.       ! Tropopause temperature (S.H. 200K)
+          CALL getin('ttp',ttp)
+          eps=0.         ! Deviation to N-S symmetry(~0-20K)
+          CALL getin('eps',eps)
+          delt_y=60.     ! Merid Temp. Gradient (S.H. 60K)
+          CALL getin('delt_y',delt_y)
+          delt_z=10.     ! Vertical Gradient (S.H. 10K)
+          CALL getin('delt_z',delt_z)
+          ! Polar vortex
+          ok_pv=.false.
+          CALL getin('ok_pv',ok_pv)
+          phi_pv=-50.            ! Latitude of edge of vortex
+          CALL getin('phi_pv',phi_pv)
+          phi_pv=phi_pv*pi/180.
+          dphi_pv=5.             ! Width of the edge
+          CALL getin('dphi_pv',dphi_pv)
+          dphi_pv=dphi_pv*pi/180.
+          gam_pv=4.              ! -dT/dz vortex (in K/km)
+          CALL getin('gam_pv',gam_pv)
+          
+          ! 2. Initialize fields towards which to relax
+          ! Friction
+          knewt_g=k_c_a
           DO l=1,llm
-            zsig=ap(l)/preff+bp(l)
-            if (zsig.gt.0.3) then
-             lsup=l
-             tetarappell=1./8.*(-log(zsig)-.5)
-             DO j=1,jjp1
-             ddsin=sin(rlatu(j))-sin(pi/20.)
-             tetajl(j,l)=300.*(1+1./18.*(1.-3.*ddsin*ddsin)+tetarappell)
-             ENDDO
-            else
-c   Choix isotherme au-dessus de 300 mbar
-             do j=1,jjp1
-               tetajl(j,l)=tetajl(j,lsup)*(0.3/zsig)**kappa
-             enddo
-            endif ! of if (zsig.gt.0.3)
+           zsig=presnivs(l)/preff
+           knewt_t(l)=(k_c_s-k_c_a)*MAX(0.,(zsig-0.7)/0.3)
+           kfrict(l)=k_f*MAX(0.,(zsig-0.7)/0.3)
+          ENDDO
+          DO j=1,jjp1
+            clat4((j-1)*iip1+1:j*iip1)=cos(rlatu(j))**4
+          ENDDO
+          
+          ! Potential temperature 
+          DO l=1,llm
+           zsig=presnivs(l)/preff
+           tetastrat=ttp*zsig**(-kappa)
+           tetapv=tetastrat
+           IF ((ok_pv).AND.(zsig.LT.0.1)) THEN
+               tetapv=tetastrat*(zsig*10.)**(kappa*cpp*gam_pv/1000./g)
+           ENDIF
+           DO j=1,jjp1
+             ! Troposphere
+             ddsin=sin(rlatu(j))
+             tetajl(j,l)=teta0-delt_y*ddsin*ddsin+eps*ddsin
+     &           -delt_z*(1.-ddsin*ddsin)*log(zsig)
+             ! Profil stratospherique isotherme (+vortex)
+             w_pv=(1.-tanh((rlatu(j)-phi_pv)/dphi_pv))/2.
+             tetastrat=tetastrat*(1.-w_pv)+tetapv*w_pv             
+             tetajl(j,l)=MAX(tetajl(j,l),tetastrat)  
+           ENDDO
           ENDDO ! of DO l=1,llm
+ 
+!          CALL writefield('theta_eq',tetajl)
 
           do l=1,llm
@@ -165,56 +218,68 @@
           enddo
 
-c       call dump2d(jjp1,llm,tetajl,'TEQ   ')
-
-          CALL pression ( ip1jmp1, ap, bp, ps, p       )
-          CALL exner_hyb( ip1jmp1, ps, p,alpha,beta, pks, pk, pkf )
-          CALL massdair(p,masse)
-
-c  intialisation du vent et de la temperature
-          teta(:,:)=tetarappel(:,:)
-          CALL geopot(ip1jmp1,teta,pk,pks,phis,phi)
-          call ugeostr(phi,ucov)
-          vcov=0.
-          q(:,:,1   )=1.e-10
-          q(:,:,2   )=1.e-15
-          q(:,:,3:nqtot)=0.
-
-
-c   perturbation aleatoire sur la temperature
-          idum  = -1
-          zz = ran1(idum)
-          idum  = 0
-          do l=1,llm
-            do ij=iip2,ip1jm
-              teta(ij,l)=teta(ij,l)*(1.+0.005*ran1(idum))
+
+!         else
+!          write(lunout,*)"iniacademic: planet types other than earth",
+!     &                   " not implemented (yet)."
+!          stop
+!         endif ! of if (planet_type=="earth")
+
+          ! 3. Initialize fields (if necessary)
+          IF (.NOT. read_start) THEN
+            ! surface pressure
+            ps(:)=preff
+            ! ground geopotential
+            phis(:)=0.
+            
+            CALL pression ( ip1jmp1, ap, bp, ps, p       )
+            CALL exner_hyb( ip1jmp1, ps, p,alpha,beta, pks, pk, pkf )
+            CALL massdair(p,masse)
+
+            ! bulk initialization of temperature
+            teta(:,:)=tetarappel(:,:)
+            
+            ! geopotential
+            CALL geopot(ip1jmp1,teta,pk,pks,phis,phi)
+            
+            ! winds
+            if (ok_geost) then
+              call ugeostr(phi,ucov)
+            else
+              ucov(:,:)=0.
+            endif
+            vcov(:,:)=0.
+            
+            ! bulk initialization of tracers
+            if (planet_type=="earth") then
+              ! Earth: first two tracers will be water
+              do i=1,nqtot
+                if (i.eq.1) q(:,:,i)=1.e-10
+                if (i.eq.2) q(:,:,i)=1.e-15
+                if (i.gt.2) q(:,:,i)=0.
+              enddo
+            else
+              q(:,:,:)=0
+            endif ! of if (planet_type=="earth")
+
+            ! add random perturbation to temperature
+            idum  = -1
+            zz = ran1(idum)
+            idum  = 0
+            do l=1,llm
+              do ij=iip2,ip1jm
+                teta(ij,l)=teta(ij,l)*(1.+0.005*ran1(idum))
+              enddo
             enddo
-          enddo
-
-          do l=1,llm
-            do ij=1,ip1jmp1,iip1
-              teta(ij+iim,l)=teta(ij,l)
+
+            ! maintain periodicity in longitude
+            do l=1,llm
+              do ij=1,ip1jmp1,iip1
+                teta(ij+iim,l)=teta(ij,l)
+              enddo
             enddo
-          enddo
-
-
-
-c     PRINT *,' Appel test_period avec tetarappel '
-c     CALL  test_period ( ucov,vcov,tetarappel,q,p,phis )
-c     PRINT *,' Appel test_period avec teta '
-c     CALL  test_period ( ucov,vcov,teta,q,p,phis )
-
-c   initialisation d'un traceur sur une colonne
-          j=jjp1*3/4
-          i=iip1/2
-          ij=(j-1)*iip1+i
-          q(ij,:,3)=1.
+
+          ENDIF ! of IF (.NOT. read_start)
         endif ! of if (iflag_phys.eq.2)
         
-      else
-        write(lunout,*)"iniacademic: planet types other than earth",
-     &                 " not implemented (yet)."
-        stop
-      endif ! of if (planet_type=="earth")
-      return
       END
 c-----------------------------------------------------------------------
Index: /LMDZ5/trunk/libf/dyn3dpar/initfluxsto_p.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3dpar/initfluxsto_p.F	(revision 1453)
+++ /LMDZ5/trunk/libf/dyn3dpar/initfluxsto_p.F	(revision 1454)
@@ -203,9 +203,10 @@
      .              llm, nivsigs, zvertiid)
 c pour le fichier def
-      nivd(1) = 1
-      call histvert(filedid, 'sig_s', 'Niveaux sigma',
-     .  'sigma_level',
-     .              1, nivd, dvertiid)
-
+      if (mpi_rank==0) then
+         nivd(1) = 1
+         call histvert(filedid, 'sig_s', 'Niveaux sigma',
+     .        'sigma_level',
+     .        1, nivd, dvertiid)
+      endif
 C
 C  Appels a histdef pour la definition des variables a sauvegarder
@@ -282,9 +283,9 @@
       call histend(fileid)
       call histend(filevid)
-      call histend(filedid)
+      if (mpi_rank==0) call histend(filedid)
       if (ok_sync) then
         call histsync(fileid)
         call histsync(filevid)
-        call histsync(filedid)
+        if (mpi_rank==0) call histsync(filedid)
       endif
 	
Index: /LMDZ5/trunk/libf/dyn3dpar/integrd_p.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3dpar/integrd_p.F	(revision 1453)
+++ /LMDZ5/trunk/libf/dyn3dpar/integrd_p.F	(revision 1454)
@@ -6,5 +6,5 @@
      $     dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps0,masse,phis,finvmaold)
       USE parallel
-      USE control_mod
+      USE control_mod, only : planet_type
       IMPLICIT NONE
 
@@ -279,5 +279,4 @@
 
           CALL qminimum_p( q, nq, deltap )
-	 endif ! of if (planet_type.eq."earth")
 c
 c    .....  Calcul de la valeur moyenne, unique  aux poles pour  q .....
@@ -337,4 +336,7 @@
       ENDDO
 c$OMP END DO NOWAIT
+
+      endif ! of if (planet_type.eq."earth")
+
 c
 c
Index: /LMDZ5/trunk/libf/dyn3dpar/leapfrog_p.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3dpar/leapfrog_p.F	(revision 1453)
+++ /LMDZ5/trunk/libf/dyn3dpar/leapfrog_p.F	(revision 1454)
@@ -234,5 +234,5 @@
 
 c$OMP MASTER
-      dq=0.
+      dq(:,:,:)=0.
       CALL pression ( ip1jmp1, ap, bp, ps, p       )
       CALL exner_hyb( ip1jmp1, ps, p,alpha,beta, pks, pk, pkf )
@@ -596,15 +596,10 @@
      .        flxw,pk, iapptrac)
 
-       IF (offline) THEN
-Cmaf stokage du flux de masse pour traceurs OFF-LINE
-
-#ifdef CPP_IOIPSL
-           CALL fluxstokenc_p(pbaru,pbarv,masse,teta,phi,phis,
-     .   dtvr, itau)
-#endif
-
-
-         ENDIF ! of IF (offline)
-c
+C        Stokage du flux de masse pour traceurs OFF-LINE
+         IF (offline .AND. .NOT. adjust) THEN
+            CALL fluxstokenc_p(pbaru,pbarv,masse,teta,phi,phis,
+     .           dtvr, itau)
+         ENDIF
+
       ENDIF ! of IF( forward. OR . leapf )
 cc$OMP END PARALLEL
@@ -968,15 +963,14 @@
 
       IF(iflag_phys.EQ.2) THEN ! "Newtonian" case
-c   Calcul academique de la physique = Rappel Newtonien + fritcion 
-c   --------------------------------------------------------------
-cym       teta(:,:)=teta(:,:)
-cym     s  -iphysiq*dtvr*(teta(:,:)-tetarappel(:,:))/taurappel
+!   Academic case : Simple friction and Newtonan relaxation 
+!   -------------------------------------------------------
        ijb=ij_begin
        ije=ij_end
 !$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
        do l=1,llm
-       teta(ijb:ije,l)=teta(ijb:ije,l)
-     &  -iphysiq*dtvr*(teta(ijb:ije,l)-tetarappel(ijb:ije,l))/taurappel
-       enddo
+        teta(ijb:ije,l)=teta(ijb:ije,l)-dtvr*
+     &         (teta(ijb:ije,l)-tetarappel(ijb:ije,l))*
+     &                  (knewt_g+knewt_t(l)*clat4(ijb:ije))
+       enddo ! of do l=1,llm
 !$OMP END DO
 
@@ -987,8 +981,37 @@
        call WaitRequest(Request_Physic)     
 c$OMP BARRIER
-!$OMP MASTER
-       call friction_p(ucov,vcov,iphysiq*dtvr)
-!$OMP END MASTER
+       call friction_p(ucov,vcov,dtvr)
 !$OMP BARRIER
+
+        ! Sponge layer (if any)
+        IF (ok_strato) THEN
+          ! set dufi,dvfi,... to zero
+          ijb=ij_begin
+          ije=ij_end
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+          do l=1,llm
+            dufi(ijb:ije,l)=0
+            dtetafi(ijb:ije,l)=0
+            dqfi(ijb:ije,l,1:nqtot)=0
+          enddo
+!$OMP END DO
+!$OMP SINGLE
+          dpfi(ijb:ije)=0
+!$OMP END SINGLE
+          ijb=ij_begin
+          ije=ij_end
+          if (pole_sud) ije=ije-iip1
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+          do l=1,llm
+            dvfi(ijb:ije,l)=0
+          enddo
+!$OMP END DO
+
+          CALL top_bound_p(vcov,ucov,teta,masse,dufi,dvfi,dtetafi)
+          CALL addfi_p( dtvr, leapf, forward   ,
+     $                  ucov, vcov, teta , q   ,ps ,
+     $                 dufi, dvfi, dtetafi , dqfi ,dpfi  )
+!$OMP BARRIER
+        ENDIF ! of IF (ok_strato) 
       ENDIF ! of IF(iflag_phys.EQ.2)
 
@@ -1465,9 +1488,9 @@
 c$OMP MASTER
 
-              if (planet_type.eq."earth") then
+!              if (planet_type.eq."earth") then
 ! Write an Earth-format restart file
                 CALL dynredem1_p("restart.nc",0.0,
      &                           vcov,ucov,teta,q,masse,ps)
-              endif ! of if (planet_type.eq."earth")
+!              endif ! of if (planet_type.eq."earth")
 
 !              CLOSE(99)
@@ -1658,10 +1681,10 @@
 
               IF(itau.EQ.itaufin) THEN
-                if (planet_type.eq."earth") then
+!                if (planet_type.eq."earth") then
 c$OMP MASTER
                    CALL dynredem1_p("restart.nc",0.0,
      .                               vcov,ucov,teta,q,masse,ps)
 c$OMP END MASTER
-                endif ! of if (planet_type.eq."earth")
+!                endif ! of if (planet_type.eq."earth")
               ENDIF ! of IF(itau.EQ.itaufin)
 
Index: /LMDZ5/trunk/libf/dyn3dpar/limit_netcdf.F90
===================================================================
--- /LMDZ5/trunk/libf/dyn3dpar/limit_netcdf.F90	(revision 1453)
+++ /LMDZ5/trunk/libf/dyn3dpar/limit_netcdf.F90	(revision 1454)
@@ -97,5 +97,5 @@
   kappa = 0.2857143
   cpp   = 1004.70885
-  dtvr  = daysec/FLOAT(day_step)
+  dtvr  = daysec/REAL(day_step)
   CALL inigeom
 
@@ -265,6 +265,4 @@
 
   DEALLOCATE(pctsrf_t,phy_sst,phy_bil,phy_alb,phy_rug)
-#endif
-! of #ifdef CPP_EARTH
 
 
@@ -592,7 +590,7 @@
 
 !--- Mid-months times
-  mid_months(1)=0.5*FLOAT(mnth(1))
+  mid_months(1)=0.5*REAL(mnth(1))
   DO k=2,nm
-    mid_months(k)=mid_months(k-1)+0.5*FLOAT(mnth(k-1)+mnth(k))
+    mid_months(k)=mid_months(k-1)+0.5*REAL(mnth(k-1)+mnth(k))
   END DO
 
@@ -626,4 +624,6 @@
 !-------------------------------------------------------------------------------
 
+#endif
+! of #ifdef CPP_EARTH
 
 END SUBROUTINE limit_netcdf
Index: /LMDZ5/trunk/libf/phylmd/calcul_divers.h
===================================================================
--- /LMDZ5/trunk/libf/phylmd/calcul_divers.h	(revision 1453)
+++ /LMDZ5/trunk/libf/phylmd/calcul_divers.h	(revision 1454)
@@ -2,28 +2,23 @@
 c $Header$
 c
-c
-c initialisations diverses au "debut" du mois
-c
-      IF(MOD(itap,INT(ecrit_mth/dtime)).EQ.1) THEN
+
+c     Initialisations diverses au "debut" du mois
+      IF(debut) THEN
+         nday_rain(:)=0.
+
+c        surface terre
+         paire_ter(:)=0.
          DO i=1, klon
-          nday_rain(i)=0.
-         ENDDO !i
-c
-c surface terre
-       DO i=1, klon
-         IF(pctsrf(i,is_ter).GT.0.) THEN
-            paire_ter(i)=airephy(i)*pctsrf(i,is_ter)
-         ENDIF 
-       ENDDO
-c
-      ENDIF !MOD(itap,INT(ecrit_mth)).EQ.1
-c
-      IF(MOD(itap,INT(ecrit_day/dtime)).EQ.0) THEN
-c
-cIM calcul total_rain, nday_rain
-c
-       DO i = 1, klon
-        total_rain(i)=rain_fall(i)+snow_fall(i)  
-        IF(total_rain(i).GT.0.) nday_rain(i)=nday_rain(i)+1.
-       ENDDO
-      ENDIF !itap.EQ.ecrit_mth
+            IF(pctsrf(i,is_ter).GT.0.) THEN
+               paire_ter(i)=airephy(i)*pctsrf(i,is_ter)
+            ENDIF 
+         ENDDO
+      ENDIF
+
+cIM   Calcul une fois par jour : total_rain, nday_rain
+      IF(MOD(itap,INT(un_jour/dtime)).EQ.0) THEN
+         DO i = 1, klon
+            total_rain(i)=rain_fall(i)+snow_fall(i)  
+            IF(total_rain(i).GT.0.) nday_rain(i)=nday_rain(i)+1.
+         ENDDO
+      ENDIF
